interface SafeCallable<T> {
    (): T | undefined;
    <K>(fallback: K): K | T;
}
declare type SafeProps<T> = {
    readonly [P in keyof T]-?: SafeTouch<T[P]>;
} & {
    [P: string]: SafeTouch<any>;
};
declare type Safe<T> = SafeProps<T> & SafeCallable<T>;
declare type SafeTouch<T> = T extends undefined | number | boolean ? Safe<any> : Safe<T>;
declare function touch(source?: undefined): SafeTouch<any>;
declare function touch<T>(source: T): SafeTouch<T>;
export declare const safeTouch: typeof touch;
export default touch;
